# Pipeline开发流程 #
本文档主要给出了SRP需要上架时，开发Pipeline过程中需要遵循的规范。
## 1、Pipeline 开发环境 ##
#### 1.1 Gitlab ####
每个SRP团队均有以SRPName命名的Project，相应的开发人员有developer权限。
- Gitlab Group：WISE-PaaS_SRP_Pipeline
- Gitlab Project：SRP均有以SRPName命名的Project，如RMM
- Gitlab 开发Branch：develop分支
- features-xxx分支：SRP开发团队开发过程中的Pipeline

| Project Name | developer |
| ------ | ------ |
| RMM | Tung.Yi, Sephiroth.Wang, Alex.Shao | 
| DeviceOn | Tung.Yi, Sephiroth.Wang, Alex.Shao |
| VCM | sitong.yan |
| CNC_M2I | ITsung.Shen |
| EWM | Sunsx.Sun |
| Grafana | tingting.ning |
| Scada | StevenHY.Li |
| Notification | StevenHY.Li |
| APM | hailong.dang |
| OEE | Chris.Kuo |
| FEMS | Chris.Kuo |
| SaaSComposer | Ray.Lee, Ken.Yek, Phoebe.Cheng, Sean.Tsao, Yushan.Lin, zhihao.jia |
| ECM | Alex.Shao, Sephiroth.Wang, Tung.Yi |
| Documents | Public |

#### 1.2 Blob ####
- 各个SRP会获取连接Blob开发区，对应SRP的Key。

#### 1.3 Jenkins ####
- 目前会有单独的开发环境的[Jenkins](http://jenkins-dev.eastasia.cloudapp.azure.com)。
- 各个SRP会有两组账号。一组为可以新增、编辑、删除Pipeline；一组只可以执行Pipeline，方便将开发中的Pipeline提供给其他人使用。
- 账号可以操作的Pipeline为<SRPName>*,即以SRPName为前缀的Pipeline，前缀不区分大小写。

| Pipeline前缀 | 编辑账户 | 执行账户 |
| ------ | ------ | ------ |
| RMM | rmm_edit | rmm_view |
| DeviceOn | deviceon_edit | deviceon_view |
| VCM | vcm_edit | vcm_view |
| CNC_M2I | cncm2i_edit | cncm2i_view |
| EWM | ewm_edit | ewm_view |
| Grafana | grafana_edit | grafana_view |
| Scada | scada_edit | scada_view |
| Notification | notification_edit | notification_view |
| APM | apm_edit | apm_view |
| OEE | oee_edit | oee_view |
| FEMS | fems_edit | fems_view |
| SaaSComposer | saascomposer_edit | saascomposer_view |
| ECM | ecm_edit | ecm_view |

#### 1.4 Apollo ####
- 目前会有单独的开发环境的[Apollo](http://portal-apollo-dev.eastasia.cloudapp.azure.com)。
- Apollo中填写每个SRP的上架信息。详细信息规则参考[SRPConfigSpecification](../SRPConfigSpecification.md)。
- 各个SRP有一组账号，可以针对自己SRP的上架信息进行编辑。

| 上架NameSpace | 编辑账户 | 
| ------ | ------ |
| RMM | rmm_edit | 
| DeviceOn | deviceon_edit |
| VCM | vcm_edit |
| CNC_M2I | cncm2i_edit |
| EWM | ewm_edit |
| Grafana | grafana_edit |
| Scada | scada_edit |
| APM | apm_edit |
| OEE | oee_edit |
| FEMS | fems_edit |
| SaaSComposer | saascomposer_edit |
| ECM | ecm_edit |

## 2、Pipeline开发流程 ##
![](../FlowChart/PipelineDevelopFlow.png)

- Blob中上传SRP Package。
- 在Apollo配置中心提交和发布对应SRP的Namespace config，请参考文档[SRPConfigSpecification](../SRPConfigSpecification.md) 获取配置说明。
![](../FlowChart/ApolloConfig.png)
- 调用[Listing Management API](http://listingsystem-dev.eastasia.cloudapp.azure.com/listsystem/v1/srps/rmm) 获取已经发布的SRP配置信息。注意：API只能获取发布了的配置。当提交上架Request时，需要说明Apollo配置的发布名称。  
![](../FlowChart/srpinfo.png)
- Gitlab上，SRP开发团队，每次在对应的Project中，develop分支上拉出featurexxx分支，进行Pipeline编写。
- Pipeline参考[How to write deploy pipeline](../How to write deploy pipeline.md),根据[Pipeline开发指引](../deployAppTemplate.groovy)修改。
- Jenkins上进行测试，注意Pipeline名称前缀只能为SRPName。
![](../FlowChart/Jenkins.png)
- 测试通过之后，将Gitlab上Feature-xxx分支，merge进develop分支，并打Tag v-x.x.x.x，从v-1.0.0.0开始，提交测试。
  